#!/usr/bin/perl -w

# Contains som eusefull helper functions and merely some constants for 
# the specific use with Thief, maybe later on I add more games. 

# usage: 

# use Dromed;
#
# setStyle("thief"); # or setStyle (thief()); it is also the default
# print "A solid cube would be: type: ",cube()," kind: ",solid(),"\n";

# (c) Copyright by Tels 1999-2000. All Rights Reserved. Do NOT distribute.
# Updates and support on bloodgate.com/thief
# Thanx to Doug Church at TLG

# [08/27/99] v0.0.1 - from scratch
# [08/28/99] v0.0.2 - completed
# [09/10/99] v0.0.3 - did I say "completed"? Added kind2Name and type2Name
# [09/13/99] v0.0.4 - added: flow and room
# [09/22/99] v0.0.7 - added: prisma
#                     fixed: brush2num
# [10/04/99] v0.0.8 - added: optimizeSky, xxxSided from Bunch.pm
# [10/23/99] v0.0.9 - added: area(), removed readTemplate
# 1999-11-06 v0.1.0 - added: eax stuff
#                            snap2Grid, rotatePoint, clipAngle, distance 
#                            (from Bunch)
#                            snapLength, true/false/on/off/yes/no, 
#                            turnbyFacingCw
#                            genCubesByFacing
#                     fixed: snap2Grid,snapLength work on arbitrary long lists
#                            pyramidfaces (jds)     
# 1999-11-10 v0.1.1 - fixed: rotations like in DromEd
#                     added: sky(), flipFacing, max, min, range, omni, spot
#                            light2Name, round
# 1999-12-01 v0.1.2 - fixed: optimizeSky uses sky(), copyHash
# 1999-12-01 v0.1.2 - fixed: belt,hand,genericContents
# 2000-01-09 v0.1.3 - added: rel2abs, unreal, most o_ and l_ constants
#                            printHash (for debug)
#                     fixed: snap2Grid/snap2Length in scalar context 
# 2000-01-31 v0.1.4 - added: o_obb etc, o_slay, o_humanoid etc
#                     fixed: clipAngle, PI constants 
# 2000-02-13 v0.1.5 - fixed: wantarry for turnbyfacing
# 2000-05-20 v0.1.6 - fixed: use constant, many more constants, solid2water bug
#                     added: vpyramid
# 2000-06-07 v0.1.7 - added: rgb2hsv hsv2rgb

package Cowgen::Dromed;
require Exporter;
use POSIX; # wtm - added for FLT_EPSILON
use Math::Trig; # wtm - added for matrix subs

use Data::Dumper; # for debugging

@ISA    = qw(Exporter);

# wtm added spot to exports
# wtm added addAngles, getNormals
@EXPORT = qw( 
             solid air water flood evaporate water2air solid2air air2solid 
             water2solid solid2water
             omni spot light
             rgb2hsv hsv2rgb
             blockable flow room object
             cube wedge cylinder pyramid apexpyramid dodecahedron prisma
             vpyramid
             threesided foursided fivesided sixsided sevensided eightsided 
             ninesided tensided
             jorge deftex
             
             THIEF SSHOCK2 UNREAL THIEF2 
             GAMFILE MISFILE VBRFILE SAVFILE 

             kind2Name type2Name light2Name filetype2Name version2Name

             optimizeSky 

             EAX_GENERIC EAX_PADDEDCELL EAX_ROOM EAX_BATHROOM EAX_LIVINGROOM 
             EAX_STONEROOM EAX_AUDITORIUM EAX_CONCERTHALL EAX_CAVE EAX_ARENA
             EAX_HANGAR EAX_CARPETEDHALLWAY EAX_hALLWAY EAX_STONECORRIDOR 
             EAX_ALLEY EAX_FOREST EAX_CITY
             EAX_MOUNTAINS EAX_QUARRY EAX_PLAIN EAX_PARKINGLOT EAX_SEWERPIPE 
             EAX_UNDERWATER
             EAX_DRUGGED EAX_DIZZY EAX_PSYChOTIC 

             north west east south bottom top defaultFace
             side1 side2 side3 side4 side5 side6 side7 side8 side9
             rotatePoint snap2Grid snapLength distance clipAngle 
             turnByFacingCcw genCubesByFacing flipFacing
             yes no true false on off sky
             YES NO ON OFF TRUE FALSE
             max min range round copyHash rel2abs printHash
             aNorth aWest aEast aSouth aBottom aTop aCenterX aCenterY aCenterZ
             aNorthEast aNorthWest aSouthEast aSouthWest
             NOEDGE NOWALL

             L_HAND L_BELT L_GENERIC_CONTENTS

             L_OBJECT L_VHOT L_JOINT L_SUBMODEL 

             L_HEAD L_HEACK L_ABDOMEN L_BUTT L_LEFT_SHOULDER L_RIGHT_SHOULDER 
             L_LEFT_ELBOW L_RIGHT_ELBOW L_LEFT_WRIST L_RIGHT_WRIST 
             L_LEFT_FINGERS 
             L_RIGHT_FINGERS L_LEFT_HIP L_RIGHT_HIP L_LEFT_KNEE L_RIGHT_KNEE 
             L_LEFT_TOE L_RIGHT_TOE L_TAIL 

             L_NONE L_VERY_LOW L_LOW L_NORMAL L_MODERATE L_HIGH L_VERY_HIGH 
             L_ABSOLUTE 

             L_LEVEL_LOW L_LEVEL_MEDIUM L_LEVEL_HIGH 

             L_SEEN L_HEARD L_CAN_RAYCAST L_HAVE_LOS L_BLIND L_DEAF L_HIGHEST 
             L_FIRSTHAND 

             L_STOPPED L_VERY_SLOW L_SLOW L_FAST L_VERY_FAST 

             L_LINE_OF_SIGHT L_RAYCAST 

             L_PROJECTILE_FLASH L_RANDOM_BANK 

             O_NOTHINH O_SCRIPT_MESSAGE O_PLAY_SOUND_MOTION O_ALERT 
             O_BECOME_HOSTILE O_ENABLE_INVESTIGATE O_GOTO_OBJECT O_FROB_OBJECT 
             O_WAIT O_MPRINT O_ADD_REMOVE_METAPROP O_ADD_LINK O_REMOVE_LINK 
             O_FACE O_SIGNAL O_DEST_SCRIPT_MESSAGE 
 
             L_DO_INV L_NO_WORLD L_DO_TOOLSRC L_NO_TOOLDST L_ALLOW_DIRECT

             L_PICK_UP L_WORLD_HIGHLIGHT

             O_BOUNCE O_DESTROY_ON_IMPACT O_SLAY_ON_IMPACT O_NO_COLLISION_SOUND 
             O_NO_RESULT O_FULL_COLLISION_SOUND 

             O_BLOCK_PATHFIND O_REPEL

             O_NOT_RENDERED O_UNLIT O_EDITOR_ONLY

             O_JUNK O_WEAPON O_ITEM

             O_FLIP O_SLIDE O_D_RANDOM O_MIN_BRIGHT O_MAX_BRIGHT O_ZERO_BRIGHT 
             O_SMOOTHLY_BRIGHTEN O_SMOOTHLY_DIM O_COHERENT O_FLICKER 
 
             O_ON O_REVERSE O_RESYNC O_GO_EDGE O_LAP_ONE

             O_ENVIRONMENTAL O_NO_SHARP_CURVE O_TURNED_OFF O_ONE_SHOT 
             O_AMBIENTHACKED_MUSIC O_AMBIENTHACKED_SYNC O_NOFADE O_DESTROY_OBJ O_AUTO_OFF 
            
             O_OBB O_SPHERE O_SPHERE_HAT

             O_NO_EFFECT O_TERMINATE O_DESTROY
           
             O_HUMANOID O_PLAYERARM O_PLAYERBOWARM O_BURRICK O_SPIDER O_BUGBEAST 
             O_CRAYMAN O_CONSTANTINE O_APPARITION O_SWEEL O_ROPE O_ZOMBIE 
             O_SMALLSPIDER O_FROG O_CUTTY

             O_TWEQ_DESTROY_OBJ O_REMOVE_PROP O_STOP_TWEQ O_CONTINUE O_SLAY_OBJ 

             O_NO_LIMIT O_SIM O_WRAP O_ONE_BOUNCE O_SIM_SMALL_RAD O_SIM_LARGE_RAD
             O_OFF_SCREEN

             O_JITTER_LOW O_JITTER_HIGH O_MUL

             O_ANCHOR O_SCRIPTS O_TWEQ_RANDOM O_GRAV O_ZERO_VEL O_TELLAI O_PUSHOUT
             O_NEGATIVE_VELOCITY O_RELATIVE_VELOCITY O_NOPHYSICS O_ANCHORVHOT

             O_AXIS_VELOCITY O_VELOCITY O_ROT_VELOCITY O_LOCATION O_ROTATION
             O_CLOSED O_OPEN O_CLOSING O_OPENING O_HALTED

             O_NORMAL O_DONTINVESTIGATE

             O_TEAM_GOOD O_TEAM_NORMAL O_TEAM_BAD1 O_TEAM_BAD2 O_TEAM_BAD3 
             O_TEAM_BAD4 O_TEAM_BAD5  

             O_NONE O_VERY_LOW O_LOW O_MODERATE O_HIGH O_VERY_HIGH
         
             O_ASLEEP O_SUPER_EFFICIENT O_EFFICIENT O_NORMAL_MODE O_COMBAT O_DEAD 
       
             O_NULL O_WELL_BELOW_AVERAGE O_BELOW_AVERAGE O_AVERAGE O_ABOVE_AVERAGE 
             O_WELL_ABOVE_AVERAGE
             
             O_NEVER O_ON_LOW_ALERT O_ON_MODERATE_ALERT O_ON_HIGH_ALERT O_ON_LOW_HITPOINTS 
             O_ON_THREAT
       
             O_MOVE O_SCRIPT O_DELETE O_IGNORE O_FOCUS_SCRIPT O_TOOL_CURSOR
             O_USE_AMMO O_FROB_DEFAULT O_DESELECT
             O_TAG O_MOTION
    
             O_SWING O_GENERAL_BLOCK O_DIRECTED_BLOCK

             O_DEFAULT O_ALTERNATE_MODEL O_ALTERNATE_BITMAP
             O_QUEST_VAR_0 O_QUEST_VAR_1 O_QUEST_VAR_2 O_QUEST_VAR_3 O_QUEST_VAR_4
             O_QUEST_VAR_5 O_QUEST_VAR_6 O_QUEST_VAR_7 O_QUEST_VAR_8 O_QUEST_VAR_9     
           
             O_INNOCENT O_ENEMY O_HIDDEN O_FOUND_BODY
             
             O_INFORM O_MINOR_ANOMALY O_MAJOR_ANOMALY O_NON_COMBAT_HIGH O_COMBAT_HIGH
             
             O_RANDOMIZE_TIME O_RESET_ON_FAIL
             
             O_SKY_STARS O_SKY_TEXTURE 
             
             O_VERY_RARELY O_RARELY O_SOMETIMES O_OFTEN O_VERY_OFTEN

             O_GROUNDLOCO O_MOTOR_COMBAT O_GROUND_ACTION O_PLAYER_ARM O_PLAYER_BOW O_SINGLE

             O_RETRIGGER O_PAN_POSITION O_PAN_RANGE O_NO_REPEAT O_NO_CACHE O_STREAM
             O_PLAY_ONCE O_NO_COMBAT O_NOISE O_SPEECH O_AMBIENT O_MUSIC O_METAUI

             O_NO_BROADCAST O_CUSTOM_CONCEPT

             O_SLEEPING O_ALERT_ZERO_BROADCAST O_ALERT_ONE_BROADCAST O_ALERT_TWO_BROADCAST
             O_ALERT_THREE_BROADCAST O_ALERT_TO_ONE O_ALERT_TO_TWO O_ALERT_TO_THREE  
             O_SPOT_PLAYER O_ALERT_DOWN_TO_ONE O_LOST_CONTACT O_CHARGE O_SHOOT O_FLEE O_FRIEND
             O_ALARM O_ATTACK O_ATACK_SUCCESS O_BLOCK_SUCCESS O_DETECT_BLOCK O_BLOCKED
             O_HIT_NO_DAMAGE O_HIT_HIGH_DAMAGE O_HIT_LOW_DAMAGE O_HIT_AMBUSH
             O_DIE_LOUD O_DIE_SOFT O_BROADCAST_FOUND_BODY O_SOMETHING_MISSING O_SECURITY_BREACH 
             O_SMALL_ANOMALY O_LARGE_ANOMALY O_SAW_INTRUDER O_SAW_BODY O_SAW_MISSING 
             O_SAW_SOMETHING_UNSPECIFIC O_OUT_OF_REACH

             O_BOUNDING_BOX O_CYLINDER O_PARTICLE_SPHERE 

             O_ALWAYS_TO_PLAYER O_TO_PLAYER_UNTIL_DAMAGED O_TO_PLAYER_UNTIL_THREATENED
             O_UNTIL_DAMAGED O_UNTIL_THREATENED O_ALWAYS

             O_KILL_ON_COMPLETION

             CD_DIRECT CD_INVERTED CD_ONE_SHOT CD_PROXY CD_DESTROY CD_REQUIRE_ALL CD_REQUIRE_ANY

             O_PRIORITY_VERY_LOW O_PRIORITY_LOW O_PRIORITY_NORMAL O_PRIORITY_HIGH 
             O_PRIORITY_VERY_HIGH O_PRIORITY_ABSOLUTE
         
             O_DAMAGE O_RAISED_WEAPON

             O_ACTIVE O_NO_ALERT_0 O_NO_ALERT_1 O_NO_ALERT_2 O_NO_ALERT_3 O_PERIPHERAL
             O_OMNI O_NIGHT_VISION O_BEHIND
       
             O_PLAYER_INTRUSION O_SELF_ENTRY
 
             O_LINE_OF_SIGHT O_RAYCAST

             O_DONT_KILL O_AFTER_TRIGGER O_AFTER_COMPLETION

             o_bounce

             addAngles

             getNormals
            );
#@EXPORT_OK = qw();

use Cowgen::Vbr;
use strict 'vars';

use constant PI => 4 * atan2 1,1; # was 2*3.141592654;
use constant PI2 => 2*PI;
use constant PI2_360 => PI2/360;

use constant THIEF => 0;
use constant SSHOCK2 => 1;
use constant THIEF2 => 2;
use constant UNREAL => 3;

use constant MISFILE => 0x031900;
use constant VBRFILE => 0x000500;
use constant GAMFILE => 0x040200;
use constant SAVFILE => 0x011900;

my $filetypename = { 0x031900 => 'mission', 0x000500 => 'multibrush', 0x040200 => 'gamsys',
                     0x011900 => 'save', };
my @versionname = ( 'Thief (TDP/TG)', 'System Shock 2', 'Thief 2','Unreal');

sub filetype2Name
  {
  my $t = shift || 0;
  return $filetypename->{$t} || 'unknown';
  }

sub version2Name
  {
  my $t = shift || 0;
  return $versionname[$t] || 'unknown';
  }

sub snap2Grid
  {
  # "snap" point(s) to grid, gridsize is 0.5, 1 etc (not 15,16 like in DromEd)
  # parameter: gridsize, list of coordinates to snap
  my ($gridsize,@p) = @_;
  $gridsize = 0.25 if ((!defined $gridsize) || ($gridsize == 0));
  my $s;
  foreach (@p)
    {
    $s = 0.5; $s = -0.5 if ($_ < 0);
    $_ = int( $_ / $gridsize + $s)*$gridsize;
    }
  return wantarray ? @p : $p[0]; # return as list or single value
  }

sub snapLength
  {
  # "snap" length(s) to the twice the gridsize, 
  # gridsize is 0.5, 1 etc (not 15,16 like in DromEd)
  # parameter: gridsize, list of lengths to snap
  my ($gridsize,@l) = @_;
  $gridsize = 0.25 if ((!defined $gridsize) || ($gridsize == 0));
  $gridsize = $gridsize*2;
  my $s;
  foreach (@l)
    {
    $s = 0.5; $s = -0.5 if ($_ < 0);
    $_ = int( $_ / $gridsize + $s)*$gridsize;
    }
  return wantarray ? @l : $l[0]; # return as list or single value
  }

sub max
  {
  # return maximum element
  my $max = -1000000;
  my $m;
  foreach $m (@_) { $max = $m if ($m > $max); }
  return $max;
  }

sub min
  {
  # return minimum element
  my $min = 1000000;
  my $m;
  foreach $m (@_) { $min = $m if ($m < $min); }
  return $min;
  }

sub range
  {
  # return element that it is in range
  my $e = shift || 0;
  my ($min,$max) = @_;
  $e = $min if ($e < $min);
  $e = $max if ($e > $max);
  return ($e);
  }

sub round
  {
  my ($v,$r) = @_;
  return int(($r*$v)+0.50)/$r if ($v > 0);
  return int(($r*$v)-0.50)/$r;
  }

sub rel2abs
  {
  # Take a relative value (-1 <= val < 0) and return it as an absolute
  # value based on size. Output is clipped to be between 0 and size if cut != 0. 
  # value can be undefined and will be assumed to be 0.
  # Examples: -0.5,9 = 4.5; 0,9 = 0; 4,9 = 4; 10,9 = 9; -2,9 = 9; etc
  # Parameters: relativecoord, size, cut (1 to cut at size)
  my $rel = shift || return 0;
  my $size = shift;
  my $cut = shift || 0;
  if ($cut != 0)
    {  
    return $rel if ($rel >= 0);
    return -$rel*$size;
    }
  return range($rel,0,$size) if ($rel >= 0);
  return range(-$rel*$size,0,$size);
  }

sub distance
  {
  # calculate disctance betweentwo 3D points (w/o sqr for speedup)
  # parameter: x,y,z, x1,y1,z2
  my ($x1,$y1,$z1,$x2,$y2,$z2) = @_;
  my ($x,$y,$z);

  $x = ($x2-$x1); $x = $x*$x; $y = ($y2-$y1); $y = $y*$y;
  $z = ($z2-$z1); $z = $z*$z;
  return ($z+$x+$y);
  }

sub clipAngle
  {
  # correct angle values of list to be between 0..360
  # usage: clipAngle(@list) or clipAngle($a1,$a2,$a3,$a4, aso)
  foreach (@_) { $_ += 360 while ($_ < 0); $_ -= 360 while ($_ >= 360); }
  }

sub rotatePoint
  {
  # rotate a point in 3D space
  # parameter: x (point to rotate),y,z, px (pivot point), py, pz, ax (angle), ay, az
  my ($x,$y,$z,$px,$py,$pz,$ax,$ay,$az) = @_;
  clipAngle($ax,$ay,$az);
  my ($x2,$y2,$z2);
 
  $ax = $ax*PI2_360; $ay = $ay*PI2_360; $az = $az*PI2_360;

  my $caz = cos($az); my $saz = sin($az); 
  my $cax = cos($ax); my $sax = sin($ax); 
  my $cay = cos($ay); my $say = sin($ay);

  $x -= $px; $y -= $py; $z -= $pz;
  $y2 = $y * $cax - $z * $sax;
  $z = $y * $sax + $z * $cax;
  $y = $y2;

  $x2 = $x * $cay + $z * $say;
  $z = -$x * $say + $z * $cay;
  $x = $x2;

  $x2 = $x * $caz - $y * $saz;
  $y = $x * $saz + $y * $caz;
  
  return ($x2+$px,$y+$py,$z+$pz);
  }

# rx = x
# ry = y * cos(a) - z * sin(a)
# rz = y * sin(a) + z * cos(a)
#
# rx = x * cos(a) + z * sin(a)
# ry = y
# rz = -x * sin(a) + z * cos(a)
#
# rx = x * cos(a) - y * sin(a)
# ry = x * sin(a) + y * cos(a)
# rz = z

sub turnByFacingCcw
  {
  # turn all angles in list counter-clockwise (like in DromEd) by the 
  # facing (aSouth=0,aEast=90,ANorth=180,aWest=270)
  my ($facing,@r) = @_;
  foreach $a (@r)
    {
    $a += 90 if ($facing == aEast());
    $a += 180 if ($facing == aNorth());
    $a += 270 if ($facing == aWest());
    $a -= 360 if ($a >= 360);
    }
  return wantarray ? @r : $r[0]; # return as list or single value
  }

sub genCubesByFacing
  {
  # rotate a cube (facing aSouth) around a given pivot center by taking a 
  # bitfield which
  # defines aSouth, aNorth etc and return as a list the coordinates of new
  # cube center
  # and dimensions (e.g. x,y,z,w,h,l,x1,y1,z1,w1,h1,l1,x2 ...).  
  # use is depricated since $bunch->rotate and rotatebyfacing will do a better job
  # paramater: pivotx,pivoty,pivotz,cubew,cubel,cubeh, facingfield
  my ($px,$py,$pz,$x,$y,$z,$w,$h,$l, $facing) = @_;
  my @p;
  if (($facing & aSouth()) != 0)
    { 
    push (@p, $x,$y,$z,$w,$l,$h, aSouth());
    }
  if (($facing & aEast()) != 0)
    { 
    push (@p, rotatePoint ($x,$y,$z,$px,$py,$pz,90,0,0) );
    push (@p, $l,$w,$h, aEast() );
    }
  if (($facing & aNorth()) != 0)
    { 
    push (@p, rotatePoint ($x,$y,$z,$px,$py,$pz,180,0,0) );
    push (@p, $w,$l,$h, aNorth() );
    }
  if (($facing & aWest()) != 0)
    { 
    push (@p, rotatePoint ($x,$y,$z,$px,$py,$pz,270,0,0) );
    push (@p, $l,$w,$h, aWest() );
    }
  return @p;
  }

sub flipFacing
  {
  # take facing aSouth(), etc and flip it (aSouth <=> aNorth, aWest <=> aEst)
  my $facing = shift || aSouth();
  return aNorth() if ($facing == aSouth());
  return aSouth() if ($facing == aNorth());
  return aWest() if ($facing == aEast());
  return aEast() if ($facing == aWest());
  }

sub sky
  {
  # return 249 (nr of sky texture)
  249;
  }

use constant NO => 0;
use constant YES => 1;
use constant FALSE => 0;
use constant TRUE => 1;
use constant OFF => 0;
use constant ON => 1;

sub no { 0; }
sub yes { 1; }
sub off { 0; }
sub on { 1; }
sub false { 0; }
sub true { 1; }

sub deftex { return 65535; } # actually -1
sub jorge { return 0; }


sub cube { 0; }
sub cylinder { 1; }
sub pyramid { 2; }
sub apexpyramid { 3; }
sub wedge { 4; }
sub dodecahedron { 5; }
sub prisma { 6; }       # really is 3-sided cylinder
sub vpyramid { 0x80; }  # virtual brush

use constant JORGE => 0;
use constant DEFTEX => 65535;

use constant CUBE => 0;
use constant CYLINDER => 1;
use constant PYRAMID => 2;
use constant APEXPYRAMID => 3;
use constant WEDGE => 4;
use constant DODECAHEDRON => 5;
use constant PRISMA => 6;  # really is 3-sided cylinder
use constant TWOCENTEREDPYRAMID => 0x101; # 2 pyramids and one prisma

# "special" brushes
use constant OMNI => 0;
use constant SPOT => 1;

sub omni { 0; } 
sub spot { 1; } 

sub solid { 0; }
sub air { 1; }
sub water { 2; }
sub flood { 3; }
sub evaporate { 4; }
sub solid2water { 5; }
sub solid2air { 6; }
sub air2solid { 7; }
sub water2solid { 8; }
sub blockable { 9; }
sub room   { 0xFB; }
sub flow   { 0xFC; }
sub object { 0xFD; }
sub area   { 0xFE; }
sub light  { 0xFF; }

sub threesided { 0x3000;}
sub foursided { 0x4000; }
sub fivesided { 0x5000; }
sub sixsided { 0x6000; }
sub sevensided { 0x7000; }
sub eightsided { 0x8000; }
sub ninesided { 0x9000; }
sub tensided { 0xa000; }

# all values +1 because of 0 for default
# these are the eax_values for the mission default eax

use constant EAX_GENERIC => 0x01; 
use constant EAX_PADDEDCELL => 0x02; 
use constant EAX_ROOM => 0x03; 
use constant EAX_BATHROOM => 0x04; 
use constant EAX_LIVINGROOM => 0x05; 
use constant EAX_STONEROOM => 0x06; 
use constant EAX_AUDITORIUM => 0x07; 
use constant EAX_CONCERTHALL => 0x08; 
use constant EAX_CAVE => 0x09; 
use constant EAX_ARENA => 0x0a; 
use constant EAX_HANGAR => 0x0b; 
use constant EAX_CARPETEDHALLWAY => 0x0c; 
use constant EAX_HALLWAY => 0x0d; 
use constant EAX_STONECORRIDOR => 0x0d; 
use constant EAX_ALLAY => 0x0e; 
use constant EAX_FOREST => 0x0f; 
use constant EAX_CITY => 0x10; 
use constant EAX_MOUNTAINS => 0x11; 
use constant EAX_QUARRY => 0x12; 
use constant EAX_PLAIN => 0x13; 
use constant EAX_PARKINGLOT => 0x14; 
use constant EAX_SERWRPIPE => 0x15; 
use constant EAX_UNDERWATER => 0x16; 
use constant EAX_DRUGGED => 0x17; 
use constant EAX_DIZZY => 0x18; 
use constant EAX_PSYCHOTIC => 0x19; 

# misc obj stuff

# ld means link (data), o = object property

# contains
use constant L_HAND => 0xFFFFFFFF; 
use constant L_BELT => 0xFFFFFFFE; 
use constant L_GENERIC_CONTENTS => 0x00000000; 

# link data particleattachment datatype
use constant L_OBJECT => 0;
use constant L_VHOT => 0x1;
use constant L_JOINT => 0x2; 
use constant L_SUBMODEL => 0x3; 

# link data aigunflash
use constant L_PROJECTILE_FLASH => 0x1;
use constant L_RANDOM_BANK => 0x2; 

# link attach
use constant L_HEAD => 0x0; 
use constant L_heack => 0x1; 
use constant L_ABDOMEN => 0x2; 
use constant L_BUTT => 0x3; 
use constant L_LEFT_SHOULDER => 0x4; 
use constant L_RIGHT_SHOULDER => 0x5;
use constant L_LEFT_ELBOW => 0x6; 
use constant L_RIGHT_ELBOW => 0x7; 
use constant L_LEFT_WRIST => 0x8; 
use constant L_RIGHT_WRIST => 0x9; 
use constant L_LEFT_FINGERS => 0x0a; 
use constant L_RIGHT_FINGERS => 0x0b; 
use constant L_LEFT_HIP => 0x0c; 
use constant L_RIGHT_HIP => 0x0d; 
use constant L_LEFT_KNEE => 0x0e; 
use constant L_RIGHT_KNEE => 0x0f; 
use constant L_LEFT_TOE => 0x10; 
use constant L_RIGHT_TOE => 0x11; 
use constant L_TAIL => 0x12; 

# attack and others
use constant L_NONE => 0x0; 
use constant L_VERY_LOW => 0x1; 
use constant L_LOW => 0x2; 
use constant L_NORMAL => 0x3; 
use constant L_MODERATE => 0x3;  # some dialogs call it that way
use constant L_HIGH => 0x4; 
use constant L_VERY_HIGH => 0x5; 
use constant L_ABSOLUTE => 0x6; 

# levels
use constant L_LEVEL_LOW => 0x0; 
use constant L_LEVEL_MEDIUM => 0x1; 
use constant L_LEVEL_HIGH => 0x2; 

# awareness
use constant L_SEEN => 0x1; 
use constant L_HEARD => 0x2; 
use constant L_CAN_RAYCAST => 0x4; 
use constant L_HAVE_LOS => 0x8; 
use constant L_BLIND => 0x10; 
use constant L_DEAF => 0x20; 
use constant L_HIGHEST => 0x40; 
use constant L_FIRSTHAND => 0x80; 

# awareness
use constant L_STOPPED => 0x0; 
use constant L_VERY_SLOW => 0x1; 
use constant L_SLOW => 0x2; 
#use constant => 0x3;  # already defined as 3
use constant L_FAST => 0x4; 
use constant L_VERY_FAST => 0x5; 

# watchobj
#sub l_none => 0x0;} # already defined
use constant L_LINE_OF_SIGHT => 0x1; 
use constant L_RAYCAST => 0x2; 

# response
use constant O_NOTHINH => 0;
use constant O_SCRIPT_MESSAGE => 1;
use constant O_PLAY_SOUND_MOTION => 2;
use constant O_ALERT => 3;
use constant O_BECOME_HOSTILE => 4;
use constant O_ENABLE_INVESTIGATE => 5;
use constant O_GOTO_OBJECT => 6;
use constant O_FROB_OBJECT => 7;
use constant O_WAIT => 8;
use constant O_MPRINT => 9;
use constant O_ADD_REMOVE_METAPROP => 10;
use constant O_ADD_LINK => 11;
use constant O_REMOVE_LINK => 12;
use constant O_FACE => 13;
use constant O_SIGNAL => 14;
use constant O_DEST_SCRIPT_MESSAGE => 15;

# frobproxymask
use constant L_DO_INV => 1;
use constant L_NO_WORLD => 2;
use constant L_DO_TOOLSRC => 4;
use constant L_NO_TOOLDST => 8;
use constant L_ALLOW_DIRECT => 0x10;

# voice over
use constant L_WORLD_HIGHLIGHT => 1;
use constant L_PICK_UP => 2;

# object properties
# collision type
use constant O_BOUNCE => 0x1; 
use constant O_DESTROY_ON_IMPACT => 0x2; 
use constant O_SLAY_ON_IMPACT => 0x4; 
use constant O_NO_COLLISION_SOUND => 0x8; 
use constant O_NO_RESULT => 0x10; 
use constant O_FULL_COLLISION_SOUND => 0x20; 

use constant O_BLOCK_PATHFIND => 1;
use constant O_REPEL => 2;

# normal is used more than once
use constant O_NORMAL => 0;

# render type
use constant O_NOT_RENDERED  => 0x1; 
use constant O_UNLIT => 0x2; 
use constant O_EDITOR_ONLY => 3;

# inventory type
use constant O_JUNK => 0;
use constant O_ITEM => 1;
use constant O_WEAPON => 2;

# animlight
use constant O_FLIP => 0x0; 
use constant O_SLIDE => 0x1; 
use constant O_D_RANDOM => 0x2; 
use constant O_MIN_BRIGHT => 0x3;
use constant O_MAX_BRIGHT => 0x4; 
use constant O_ZERO_BRIGHT => 0x5; 
use constant O_SMOOTHLY_BRIGHTEN => 0x6; 
use constant O_SMOOTHLY_DIM => 0x7; 
use constant O_COHERENT => 0x8; 
use constant O_FLICKER => 0x9; 

# anim flags (tweq etc)
use constant O_ON => 1;
use constant O_REVERSE => 2;
use constant O_RESYNC => 4;
use constant O_GO_EDGE => 8;
use constant O_LAP_ONE => 0x10;

# ambienthacked (O_SYNC/O_MUSIC already resered)
use constant O_ENVIRONMENTAL => 0x1; 
use constant O_NO_SHARP_CURVE => 0x2; 
use constant O_TURNED_OFF => 0x4; 
use constant O_ONE_SHOT => 0x8; 
use constant O_AMBIENTHACKED_MUSIC => 0x10; 
use constant O_AMBIENTHACKED_SYNC => 0x20; 
use constant O_NOFADE => 0x40; 
use constant O_DESTROY_OBJ => 0x80; 
use constant O_AUTO_OFF => 0x100; 

# slay
use constant O_NO_EFFECT => 1;
use constant O_TERMINATE => 2;
use constant O_DESTROY => 3;

# slay
use constant O_OBB => 0;
use constant O_SPHERE => 1;
use constant O_SPHERE_HAT => 2;

# creature type
use constant O_HUMANOID => 0;
use constant O_PLAYERARM => 1;
use constant O_PLAYERBOWARM => 2;
use constant O_BURRCIK => 3;
use constant O_SPIDER => 4;
use constant O_BUGBEAST => 5;
use constant O_CRAYMAN => 6;
use constant O_CONSTANTINE => 7;
use constant O_APPARITION => 8;
use constant O_SWEEL => 9;
use constant O_ROPE => 10;
use constant O_ZOMBIE => 11;
use constant O_SMALLSPIDER => 12;
use constant O_FROG => 13;
use constant O_CUTTY => 14;

# tweq
use constant O_TWEQ_DESTROY_OBJ => 0;
use constant O_REMOVE_PROP => 1;
use constant O_STOP_TWEQ => 2;
use constant O_CONTINUE => 3;
use constant O_SLAY_OBJ => 4;

use constant O_NO_LIMIT => 1;
use constant O_SIM => 2;
use constant O_WRAP => 0x4; 
use constant O_ONE_BOUNCE => 0x8; 
use constant O_SIM_SMALL_RAD =>  0x10; 
use constant O_SIM_LARGE_RAD => 0x20; 
use constant O_OFF_SCREEN => 0x40; 

use constant O_JITTER_LOW => 0x1; 
use constant O_JITTER_HIGH => 0x2; 
use constant O_MUL => 0x4; 

use constant O_ANCHOR => 0x1; 
use constant O_SCRIPTS => 0x2; 
use constant O_TWEQ_RANDOM => 0x4; 
use constant O_GRAV => 0x8; 
use constant O_ZERO_VEL => 0x10; 
use constant O_TELLAI => 0x20; 
use constant O_PUSHOUT => 0x40; 
use constant O_NEGATIVE_VELOCITY => 0x80; 
use constant O_RELATIVE_VELOCITY => 0x100; 
use constant O_NOPHYSICS => 0x200; 
use constant O_ANCHORVHOT => 0x400; 


# physics, controls
use constant O_AXIS_VELOCITY => 1;
use constant O_VELOCITY => 2;
use constant O_ROT_VELOCITY => 4; 
use constant O_LOCATION => 8;
use constant O_ROTATION => 0x10;

use constant O_CLOSED => 0;
use constant O_OPEN => 1;
use constant O_CLOSING => 2;
use constant O_OPENING => 3;
use constant O_HALTED => 4;

# investigation style
use constant O_DONT_INVESTIGATE => 1;

use constant O_TEAM_GOOD => 0;
use constant O_TEAM_NORMAL => 1;
use constant O_TEAM_BAD1 => 2;
use constant O_TEAM_BAD2 => 3;
use constant O_TEAM_BAD3 => 4;
use constant O_TEAM_BAD4 => 5;
use constant O_TEAM_BAD5 => 6;

# ai->state mode/alertness
use constant O_NONE => 0;
use constant O_LOW => 1;
use constant O_MODERATE => 2;
use constant O_HIGH => 3;

# ranged combat, additional to ai->state mode/alertness
use constant O_VERY_LOW => 0;
use constant O_VERY_HIGHT => 4;

# response
# O_NONE
use constant O_PRIORITY_VERY_LOW => 1;
use constant O_PRIORITY_LOW => 2;
use constant O_PRIORITY_NORMAL => 3;
use constant O_PRIORITY_HIGH => 4;
use constant O_PRIORITY_VERY_HIGH => 5;
use constant O_PRIORITY_ABSOLUTE => 6;

use constant O_ASLEEP => 0;
use constant O_SUPER_EFFICIENT  => 1;
use constant O_EFFICIENT => 2;
use constant O_NORMAL_MODE => 3;
use constant O_COMBAT => 4;
use constant O_DEAD => 5;

# AI attributes
use constant O_NULL => 0;
use constant O_WELL_BELOW_AVERAGE => 1;
use constant O_BELOW_AVERAGE => 2;
use constant O_AVERAGE => 3;
use constant O_ABOVE_AVERAGE => 4;
use constant O_WELL_ABOVE_AVERAGE => 5;

# flee condition
use constant O_NEVER => 0;
use constant O_ON_LOW_ALERT => 1;
use constant O_ON_MODERATE_ALERT => 2;
use constant O_ON_HIGH_ALERT => 3;
use constant O_ON_LOW_HITPOINTS => 4;
use constant O_ON_THREAT => 5;

# frob info
use constant O_MOVE => 1;
use constant O_SCRIPT => 2;
use constant O_DELETE => 4;
use constant O_IGNORE => 8;
use constant O_FOCUS_SCRIPT => 16;
use constant O_TOOL_CURSOR => 32;
use constant O_USE_AMMO => 64;
use constant O_FROB_DEFAULT => 128;
use constant O_DESELECT => 256;

# creature pose
use constant O_TAG => 0;
use constant O_MOTION => 1;

# sword action type
use constant O_SWING => 0;
use constant O_GENERAL_BLOCK => 1;
use constant O_DIRECTED_BLOCK => 2;

# inv render type
use constant O_DEFAULT => 0;
use constant O_ALTERNATE_MODEL => 1;
use constant O_ALTERNATE_BITMAP => 2;

# difficulty stuff
use constant O_QUEST_VAR_0 => 1;
use constant O_QUEST_VAR_1 => 2;
use constant O_QUEST_VAR_2 => 4;
use constant O_QUEST_VAR_3 => 8;
use constant O_QUEST_VAR_4 => 16;
use constant O_QUEST_VAR_5 => 32;
use constant O_QUEST_VAR_6 => 64;
use constant O_QUEST_VAR_7 => 128;
use constant O_QUEST_VAR_8 => 256;
use constant O_QUEST_VAR_9 => 512;    

# stats
use constant O_INNOCENT   => 1;
use constant O_ENEMY      => 2;
use constant O_HIDDEN     => 4;
use constant O_FOUND_BODY => 8;

# ai sound type
use constant O_INFORM => 1;
use constant O_MINOR_ANOMALY => 2;
use constant O_MAJOR_ANOMALY => 3;
use constant O_NON_COMBAT_HIGH => 4;
use constant O_COMBAT_HIGH => 5;

# pick cfg
use constant O_RANDOMIZE_TIME => 1;
use constant O_RESET_ON_FAIL => 2;

# skymode
use constant O_SKY_STARS => 1;
use constant O_SKY_TEXTURE => 0;

# ranged combat, O_NEVER already defined
# use constant O_NEVER => 0;
use constant O_VERY_RARELY => 1;
use constant O_RARELY => 2;
use constant O_SOMETIMES => 3;
use constant O_OFTEN => 4;
use constant O_VERY_OFTEN => 5;

# motor controller
use constant O_GROUNDLOCO  => 0;
use constant O_MOTOR_COMBAT => 1; 
use constant O_GROUND_ACTION => 2; 
use constant O_PLAYER_ARM => 3;
use constant O_PLAYER_BOW => 4;
use constant O_SINGLE=> 5;

# play params
use constant O_RETRIGGER  => 1;
use constant O_PAN_POSITION => 2;
use constant O_PAN_RANGE => 4;
use constant O_NO_REPEAT => 8;
use constant O_NO_CACHE => 16;
use constant O_STREAM => 32;
use constant O_PLAY_ONCE => 64;
use constant O_NO_COMBAT => 128; 
use constant O_NOISE => 0x10000;
use constant O_SPEECH => 0x20000;
use constant O_AMBIENT => 0x40000;
use constant O_MUSIC => 0x80000;
use constant O_METAUI => 0x100000;

use constant O_NO_BROADCAST => 1;
use constant O_CUSTOM_CONCEPT => 2;

use constant O_SLEEPING => 1;
use constant O_ALERT_ZERO_BROADCAST => 2;
use constant O_ALERT_ONE_BROADCAST => 3;
use constant O_ALERT_TWO_BROADCAST => 4;
use constant O_ALERT_THREE_BROADCAST => 5;
use constant O_ALERT_TO_ONE  => 6;
use constant O_ALERT_TO_TWO  => 7;
use constant O_ALERT_TO_THREE   => 8; 
use constant O_SPOT_PLAYER  => 9;
use constant O_ALERT_DOWN_TO_ONE  => 10;
use constant O_LOST_CONTACT  => 11;
use constant O_CHARGE  => 12;
use constant O_SHOOT  => 13;
use constant O_FLEE  => 14;
use constant O_FRIEND => 15;
use constant O_ALARM  => 16;
use constant O_ATTACK  => 17;
use constant O_ATACK_SUCCESS  => 18;
use constant O_BLOCK_SUCCESS  => 19;
use constant O_DETECT_BLOCK  => 20;
use constant O_BLOCKED => 21;
use constant O_HIT_NO_DAMAGE  => 22;
use constant O_HIT_HIGH_DAMAGE  => 23;
use constant O_HIT_LOW_DAMAGE  => 24;
use constant O_HIT_AMBUSH => 25;
use constant O_DIE_LOUD  => 26;
use constant O_DIE_SOFT  => 27;
use constant O_BROADCAST_FOUND_BODY  => 28;
use constant O_SOMETHING_MISSING  => 29;
use constant O_SECURITY_BREACH  => 30;
use constant O_SMALL_ANOMALY  => 31;
use constant O_LARGE_ANOMALY  => 32;
use constant O_SAW_INTRUDER  => 33;
use constant O_SAW_BODY  => 34;
use constant O_SAW_MISSING  => 35;
use constant O_SAW_SOMETHING_UNSPECIFIC  => 36;
use constant O_OUT_OF_REACH => 37;

# particle launch info
use constant O_BOUNDING_BOX => 0;
use constant O_CYLINDER => 1;
use constant O_PARTICLE_SPHERE => 2;

# AI->AbilitySettings->NonHostile (O_NEVER = 0 already defined)
use constant O_ALWAYS_TO_PLAYER => 1;
use constant O_TO_PLAYER_UNTIL_DAMAGED => 2;
use constant O_TO_PLAYER_UNTIL_THREATENED => 3;
use constant O_UNTIL_DAMAGED => 4;
use constant O_UNTIL_THREATENED => 5;
use constant O_ALWAYS => 6;

# bitmap animation
use constant O_KILL_ON_COMPLETION => 1;

use constant O_DAMAGE => 0;
use constant O_RAISED_WEAPON => 1;

# vision description
use constant O_ACTIVE  => 1;
use constant O_NO_ALERT_0 => 2;
use constant O_NO_ALERT_1 => 4;
use constant O_NO_ALERT_2 => 8;
use constant O_NO_ALERT_3 => 0x10;
use constant O_PERIPHERAL => 0x20;
use constant O_OMNI => 0x40;
use constant O_NIGHT_VISION => 0x80;
use constant O_BEHIND => 0x100;

use constant O_PLAYER_INTRUSION  => 0;
use constant O_SELF_ENTRY => 1;
 
use constant O_LINE_OF_SIGHT => 1;
use constant O_RAYCAST => 2;

use constant O_DONT_KILL => 0;
use constant O_AFTER_TRIGGER  => 0;
use constant O_AFTER_COMPLETION => 1;

# links
use constant CD_DIRECT => 0;
use constant CD_INVERTED => 1;
use constant CD_ONE_SHOT => 2;
use constant CD_DESTROY => 4;
use constant CD_REQUIRE_ALL => 8;
use constant CD_REQUIRE_ANY => 16;

# jds (fixed by tels)
# face stuff
# -2 is second to last face (even if brush has no top face
# -1 is last face

sub defaultFace {0;}
sub side1 {1;}
sub side2 {2;}
sub side3 {3;}
sub side4 {4;}
sub side5 {5;}
sub side6 {6;}
sub side7 {7;}
sub side8 {8;}
sub north {1;}
sub west {2;}
sub south {3;}
sub east {4;}
sub top {-2;}    
sub bottom {-1;} 

# for align/facing

sub aCenterX {0x100;}
sub aCenterY {0x200;}
sub aCenterZ {0x400;}
sub aNorth {1;}
sub aWest {2;}
sub aSouth {4;}
sub aEast {8;}
sub aTop {16;}
sub aBottom {32;}

sub aNorthEast { 256; }
sub aNorthWest { 512; }
sub aSouthEast { 1024; }
sub aSouthWest { 2048; }

use constant NOEDGE => 256+512+1024+2048;
use constant NOWALL => 1+2+4+8;

sub aLeft {64;}
sub aRight {128;}

sub kind2Name
  {
  # return name for a given brush kind
  my ($kind) = @_;
  my @t = ("cube","cylinder","pyramid","corner-apex pyramid","wedge","dodecahedron","prisma");
  return $t[$kind] || "unknown";
  }

sub light2Name
  {
  # return name for a given brush light
  my ($kind) = @_;
  my @t = ("omni","spot");
  return $t[$kind] || "unknown";
  }

sub type2Name
  {
  # return name for a given type
  my ($type) = @_;
  my @t = ("solid","air","water","flood","evaporate","solid to water","solid to air","air to solid","water to solid","blockable");
  return $t[$type] || "unknown";
  }

sub optimizeSky
  {
  # set scale of all sky textures to 24
  my ($bunch) = @_;
  $bunch->scaleTexture(sky(),24); # easy isnt it? ;)
  }

sub copyHash
  {
  # when you write $copy = $hash; then you are just creating another reference
  # to the same hash, not a new hash. Modifying $copy is modifying $hash, too,
  # which is probably not what you want. use $copy = copyHash($hash) instead.
  # does no recurse copy!!
  my $hash = shift || {};
  my $copy = {};
  foreach (keys %$hash) { $copy->{$_} = $hash->{$_}; } 
  $copy;
  }

sub printHash
  {
  # print a hash contents
  my $hash = shift || {};
  print "Printing hash:\n"; foreach (keys %$hash) { print " $_ => $hash->{$_}\n"; } 
  }

sub rgb2hsv 
  {
  # convert Redgreenblue style light value to HueSaturationValue style
  # not ready yet
  my ($r,$g,$b) = @_;
  my $h = 0; 
  my $s = 0;
  my $v = 0;
  return ($h,$s,$v);
  }

sub hsv2rgb
  {
  # convert HueSaturationValue style light value to Redgreenblue style
  # not ready yet
  my ($h,$s,$v) = @_;
  my $r = 0; 
  my $g = 0;
  my $b = 0;
  return ($r,$g,$b);
  }

# This was missing - WTM
sub o_bounce { 0x1; }

# wtm - added routines for converting angles/matrices, matrix multiplication

sub addAngles {
 # add world rotation (first set of three) to object rotation (second set of three)
 my ($wx,$wy,$wz,$ox,$oy,$oz) = @_;
 clipAngle($wx,$wy,$wz,$ox,$oy,$oz);

 print "$wx, $wy, $wz, $ox, $oy, $oz\n";

 my @w=eulersToMatrix($wx,$wy,$wz);
 my @o=eulersToMatrix($ox,$oy,$oz);
 my @r=multiplyMatrices(\@w,\@o);
 my @n=eulersFromMatrix(@r);

 clipAngle(@n);
 @n;
}

sub multiplyMatrices {
 my @m1=@{$_[0]}; my @m2=@{$_[1]}; my @m3;
 for(my $i=0; $i<4; $i++) {
  for(my $j=0; $j<4; $j++) {
   $m3[$i][$j]=0;
   for(my $k=0; $k<4; $k++) {
    $m3[$i][$j]+=$m1[$i][$k]*$m2[$k][$j];
   }
  }
 }
 @m3;
}

sub eulersToMatrix {
 my ($rx,$ry,$rz)=@_;
 my ($ti,$tj,$th,$ci,$cj,$ch,$si,$sj,$sh,$cc,$cs,$sc,$ss,@m);

 $ti=deg2rad($rx);	$tj=deg2rad($ry);		$th=deg2rad($rz);
 $ci=cos($ti);		$cj=cos($tj);		$ch=cos($th);
 $si=sin($ti);		$sj=sin($tj);		$sh=sin($th);
 $cc=$ci*$ch;		$cs=$ci*$sh;		$sc=$si*$ch;	$ss=$si*$sh;

 $m[3][3]=1.0;$m[3][0]=$m[3][1]=$m[3][2]=$m[0][3]=$m[1][3]=$m[2][3]=0.0;
 $m[0][0] = $cj*$ch;	$m[0][1] = $sj*$sc-$cs;	$m[0][2] = $sj*$cc+$ss;
 $m[1][0] = $cj*$sh;	$m[1][1] = $sj*$ss+$cc;	$m[1][2] = $sj*$cs-$sc;
 $m[2][0] = -$sj;	$m[2][1] = $cj*$si;	$m[2][2] = $cj*$ci;
 @m;
}

sub eulersFromMatrix {
 my @m=@_;
 my @r;

 my $cy = sqrt($m[0][0]*$m[0][0] + $m[1][0]*$m[1][0]);
 if ($cy > 16*FLT_EPSILON) {
  $r[0]=rad2deg(atan2($m[2][1], $m[2][2]));
  $r[1]=rad2deg(atan2(-$m[2][0], $cy));
  $r[2]=rad2deg(atan2($m[1][0], $m[0][0]));
 } else {
  $r[0]=rad2deg(atan2(-$m[1][2], $m[1][1]));
  $r[1]=rad2deg(atan2(-$m[2][0], $cy));
  $r[2]=rad2deg(0);
 }
 @r;
}

sub getNormals {
 # for now just support cubes
 return {
  [-1, 0, 0, 1],
  [ 0,-1, 0, 1],
  [ 1, 0, 0, 1],
  [ 0, 1, 0, 1],
  [ 0, 0, 1, 1],
  [ 0, 0,-1, 1],
 };
}

1;

