=comment
BEGIN{
 open(STDOUT, ">mb.log");
 open(STDERR, ">$STDOUT");
 select STDERR; $| = 1;
 select STDOUT; $| = 1;
}
=cut

package MetaBrush::Convert;

require Tk;
require Win32;
use Tk;
use Win32;

require Exporter;
@ISA    = qw (Exporter);
@EXPORT = qw (
 createMetaBrush
 repeatLastMetaBrush
 importMis
 addMetaBrush
 $tl
 $mistextures
 $mb_parms
 cloneBrush2
 $gf
 configure
 slurp
 $tx
 derot
);

use Cowgen::Bunch;
use Cowgen::Dromed;
use Cowgen::Texture;
use Cowgen::TextureList;

#use Cowgen::Gamfile;
use MetaBrush::Dummy; # This dummies out GamFile, which we really don't need but Cowgen does

use POSIX;

# For debugging purposes
use Data::Dumper;
$Data::Dumper::Indent = 1;

# This gets called if a sub is referenced on a brush but doesn't exist in the config file
# It keeps Perl from stopping but returns nothing
#sub AUTOLOAD { undef; };

my $showConfig=1;

sub Convert {

 $script='./cow/MetaBrush/scripts/'.$mb_parms->{'scriptlet'};

 if(!(-f $script)){
  Win32::MsgBox "Can't find scriptlet $script\n";
  return;
 }

 my @pkg=split('/',$mb_parms->{'scriptlet'});
 my $pkg=join('::',@pkg);

 local $theSubCode =
  'package MetaBrush::'.$pkg.';'."\n".
  'use Data::Dumper;'."\n".
  'use Cowgen::Bunch;'."\n".
  'use Cowgen::Dromed;'."\n".
  'use Cowgen::Texture;'."\n".
  'use MetaBrush::Convert;'."\n".
  'sub include{eval(slurp(shift));}'."\n".
  'sub{'."\n".
  ' $brush=shift;'."\n".
  ' $numFaces=$#{$brush->{\'faces\'}}+1;'."\n".
  ' $w=$brush->{w};$l=$brush->{l};$h=$brush->{h};'."\n".
  ' $textureScheme=int($brush->{faces}[$numFaces-1]->{r}+.5);'."\n".
  ' ($j1,$j2,$j3,$j4,$j5,$textures[0])=split (\';\',$mistextures->{$brush->{texture}});'."\n".
  ' for($sideNum=0;$sideNum<5;$sideNum++){'."\n".
  '  ($j1,$j2,$j3,$j4,$j5,$textures[$sideNum+1])=split (\';\',$mistextures->{$brush->{\'faces\'}[$sideNum]->{\'t\'}});'."\n".
  ' }'."\n".
  ' $texturescale[0]=$brush->{faces}[$numFaces-1]->{s};'."\n".
  ' for($sideNum=0;$sideNum<5;$sideNum++){$texturescale[$sideNum+1]=$brush->{faces}[$sideNum]->{s};}'."\n".
  ' for($sideNum=0;$sideNum<5;$sideNum++){$extra1[$sideNum*2]=$brush->{faces}[$sideNum]->{u};}'."\n".
  ' for($sideNum=0;$sideNum<5;$sideNum++){$extra1[($sideNum*2)+1]=$brush->{faces}[$sideNum]->{v};}'."\n".
  ' for($sideNum=0;$sideNum<5;$sideNum++){$extra2[$sideNum]=$brush->{faces}[$sideNum]->{r};}'."\n".
    $typeHeader."\n".
  ' my $bunch=Cowgen::Bunch->create(\'bunch\');'."\n".
  "# BEGIN SCRIPTLET: '$script'\n".
    preprocess($script)."\n".
  "# END SCRIPTLET: '$script'\n".
  '$Data::Dumper::Indent=1;'."\n".
  '$Data::Dumper::Varname=\'mb_parms\';'."\n".
  'open PARMS, ">mb_parms.txt";'."\n".
  'print PARMS Dumper($mb_parms);'."\n".
  'close PARMS;'."\n".
  ' $bunch;'."\n".
  '}'."\n";

 undef($@);
 $theSub = eval $theSubCode;

 if($@){
  chomp($@);
  $er="\nError in file: $script\n$@\n"; 

  if($@ =~ / line (\d+)\.$/){
   my $lineno=$1+0;
   @subarry=split("\n",$theSubCode);
   $er .= "\n";
   for(my $i=$lineno-2; $i<$lineno+3; $i++){
    my $line=$subarry[$i-1];
    if(defined($line)){
     $er .= "$i: $line\n";
    }
   }
  }

  Win32::MsgBox($er);
  exit;
 }

 $gf = MetaBrush::Dummy->create(); # dummy for Cowgen::GamFile
 #$gf = Cowgen::Gamfile->create();

 my $template = Cowgen::Vbr->create('mb_template.mis');
 my $vbr = Cowgen::Vbr->create('mb_curbrush.vbr');

 $mistextures = (Cowgen::Texture->create($template->getTXT()))->{'textnum'};
 $tl = Cowgen::TextureList->create($mistextures);

 my $starttex=scalar(@{$tl->{textures}});

 # get the brush list
 #my $buf = $vbr->getChunk('BRLIST');
 my $bunch = Cowgen::Bunch->create('test');
 $bunch->fromBin($vbr,$gf);
 my $blist=$bunch->{'blist'};

 $bunch2 = Cowgen::Bunch->create('test');

 # process it

 #foreach $brush (sort by_time @$blist) {
# foreach $b (@$blist) {
#  $brush=$b;
  $brush=@$blist[0];

  #$numFaces = $#{$brush->{'faces'}}+1;
  #if ($brush->{faces}[$numFaces-1]->{t} == 0) {
   replaceBrush($bunch2,$brush);
  #} else {
  # cloneBrush();
  #}
# }

 # Test: objects in Tel's vbr's don't translate when imported, so do it here

 undef $bunch;
 $bunch = Cowgen::Bunch->create('test');
 $bunch->fromBin($template,$gf);
 foreach $b (@{$bunch->{blist}}){
  if($b->{id}+0 == $brush->{id}+0){
   $obj=$bunch2->{'olist'}->{'objects'};
   foreach $o (keys %{$obj}) {
    $obj->{$o}->{x}+=$b->{x};
    $obj->{$o}->{y}+=$b->{y};
    $obj->{$o}->{z}+=$b->{z};

    # I really don't understand why this adjustment to x
    # is necessary, but it seems to work when re-MetaBrushing
    # a brush from a vbr created by Cow. Something's strange
    # about them. :P
    $obj->{$o}->{x}-=$brush->{x};
   }
   
   last;
  }
 }

 # Test: grid-snap all non-rotated brushes
 foreach $b (@{$bunch2->{'blist'}}) {

  my $br=$b;

  if (
   (($br->{rx}==0)||($br->{rx}==90)||($br->{rx}==180)||($br->{rx}==270))&&
   (($br->{ry}==0)||($br->{ry}==90)||($br->{ry}==180)||($br->{ry}==270))&&
   (($br->{rz}==0)||($br->{rz}==90)||($br->{rz}==180)||($br->{rz}==270))
  ) {

   my $w=\$br->{w};
   my $l=\$br->{l};
   my $h=\$br->{h};

   if ($br->{rx}==90||$br->{rx}==270) {
    my $tmp=$w;
    $w=$h;
    $h=$tmp;
   }

   if ($br->{ry}==90||$br->{ry}==270) {
    my $tmp=$l;
    $l=$h;
    $h=$tmp;
   }

   if ($br->{rz}==90||$br->{rz}==270) {
    my $tmp=$w;
    $w=$l;
    $h=$tmp;
   }

   my $hw=$$w/2;
   my $hl=$$l/2;
   my $hh=$$h/2;

   my $x1=$br->{x}-$hl;
   my $y1=$br->{y}-$hw;
   my $z1=$br->{z}-$hh;

   my $x2=$x1+$$l;
   my $y2=$y1+$$w;
   my $z2=$z1+$$h;

#print "old:\tx=$br->{x}\ty=$br->{y}\tz=$br->{z}\tw=$br->{w}\tl=$br->{l}\th=$br->{h}\n";

   $x1=floor(($x1*16)+.5)/16;
   $y1=floor(($y1*16)+.5)/16;
   $z1=floor(($z1*16)+.5)/16;
   $x2=floor(($x2*16)+.5)/16;
   $y2=floor(($y2*16)+.5)/16;
   $z2=floor(($z2*16)+.5)/16;

   my $newl=$x2-$x1;
   my $neww=$y2-$y1;
   my $newh=$z2-$z1;

   my $newx=$x1+($newl/2);
   my $newy=$y1+($neww/2);
   my $newz=$z1+($newh/2);

#print "new:\tx=$newx\ty=$newy\tz=$newz\tw=$neww\tl=$newl\th=$newh\n\n";

   $br->{x}=$newx;
   $br->{y}=$newy;
   $br->{z}=$newz;

   $$w=$neww;
   $$l=$newl;
   $$h=$newh;
  } 
 }

 #put back the modified brush list
 $bunch2->stuff2vbr($vbr,$gf);

# $buf = $mis2->getChunk('BRLIST');
# $mis1->putChunkRaw('BRLIST',$buf);

# $mis1->delChunk('TXLIST', 'FAMILY');
# $mis1->texturePalette($tl->{textures});

 # Doesn't work? How to delete portalization info?
 #$mis1->delChunk('WR','AIPATH','ROOM_DB','AI_ROOM_DB');

 # save it
 $vbr->writeFile('mb_out.vbr');

 # Create list of new textures to load
 open(TEX,">mb_newtex");
 my $endtex=scalar(@{$tl->{textures}});
 for (my $i=$starttex; $i<$endtex; $i++){
  my @tex=splitTex($tl->{textures}[$i]);
  print TEX "load_a_texture $tex[0] $tex[1]\n";
 }
 close TEX;

}

sub cloneBrush {
 #$brush->{texture} = retex($brush->{texture});
 #for ($sideNum=0; $sideNum<$numFaces; $sideNum++) {
 # ($brush->{'faces'}[$sideNum])->{'t'} = retex(($brush->{'faces'}[$sideNum])->{'t'});
 #}
 my $kind=$brush->{kind};
 my $sides=(($#{$brush->{faces}})<<12);
 $bunch2->addBrush (
  $brush->{type}|$brush->{flags},
  $kind|$sides,
  $brush->{x},
  $brush->{y},
  $brush->{z},
  $brush->{w},
  $brush->{l},
  $brush->{h},
  $brush->{texture},
  $brush->{rx},
  $brush->{ry},
  $brush->{rz},
  @{$brush->{faces}},
 );
}

# Something's wrong here. It's taking the template brushes sides
# instead of the cloned brushes sides? Why?
sub cloneBrush2 {
 local $brush=shift;
 local $bunch=shift;
 local $mistextures=shift;

 my $numFaces = $#{$brush->{'faces'}}+1;
 $brush->{texture} = retex2($brush->{texture},$mistextures);
 for ($sideNum=0; $sideNum<$numFaces; $sideNum++) {
  ($brush->{'faces'}[$sideNum])->{'t'} = retex2(($brush->{'faces'}[$sideNum])->{'t'},$mistextures);
 }

 my $kind=$brush->{kind};
 my $sides=$#{$brush->{faces}}+1;

 if (($kind != cube()) && ($kind != wedge())) {
  if (($kind == pyramid()) || ($kind == apexpyramid())) {
   $sides--;
  } elsif ($kind == cylinder()) {
   $sides-=2;
  }
 }

 $bunch->addBrush (
  $brush->{type}|$brush->{flags},
  #$brush->{kind}|(($#{$brush->{sides}})<<12),
  $kind|$sides<<12,
  $brush->{x},
  $brush->{y},
  $brush->{z},
  $brush->{w},
  $brush->{l},
  $brush->{h},
  $brush->{texture},
  $brush->{rx},
  $brush->{ry},
  $brush->{rz},
  @{$brush->{faces}},
 );
}

sub addMetaBrush {
 local $bunch=shift;
 local $style=shift;
 local $substyle=shift;
 local $bunch2=Cowgen::Bunch->create('bunch');
 local $br=$bunch2->addBrush(@_);
 $bunch2->setFaceU($br,$#{$br->{'faces'}},$style);
 $bunch2->setFaceV($br,$#{$br->{'faces'}},$substyle);
 replaceBrush($bunch,$bunch2->brushById($br)); 
}

sub replaceBrush {

 local $bunch2=shift;
 local $brush=shift;

 # stuff we generally only need inside this module
 my $x = $brush->{x};
 my $y = $brush->{y};
 my $z = $brush->{z};
 my $rx = $brush->{rx};
 my $ry = $brush->{ry};
 my $rz = $brush->{rz};
 my $style = $brush->{faces}[$numFaces-1]->{u};
 my $subStyle = $brush->{faces}[$numFaces-1]->{v};

 # This calls a sub configured in the config file
 #my $bunch3 = &{$types[$style][$subStyle]}($brush);

 #print "Calling MetaBrush scriptlet '$script'\n";
 my $bunch3 = &$theSub($brush);

 if ($bunch3==undef) {
  #print "Undefined sub at index $style,$subStyle, using original brush\n";
  cloneBrush();
 } else {
  $bunch3->rotate($rx,$ry,$rz);
  $bunch3->translate($x,$y,$z);

  # Experimental, but this should eventually be in Cowgen::Bunch->rotate and Cowgen::Bunch->translate
  #rotateTex($bunch3);
  #translateTex($bunch3);

  $bunch2->merge($bunch3);
 }
}

sub slurp{local $/;open(FILE,shift) or return;<FILE>;}

sub createMetaBrush {

 $showConfig = 1;

 $scriptHash=eval(slurp('scriptHash.txt'));

 $mainwin=MainWindow->new();
 $mainwin->configure(-title=>'Select MetaBrush Type',-width=>0,-height=>0);
 #$mainwin->minsize(qw(640 480));
 #$mainwin->maxsize(qw(640 480));

 $c1=$mainwin->Pane()->pack();
 $mbtypes=$c1->Listbox(-selectmode=>'single', -height=>'11')->pack(-side=>'left');
 foreach $k (sort {uc($a) cmp uc($b);} keys %$scriptHash){
  $mbtypes->insert('end',$k);
 }

 $mbscripts=$c1->Listbox(-selectmode=>'single', -height=>'11')->pack(-side=>'left');

 $photo=$mainwin->Photo('image');
 $c=$c1->Label(-width=>176,-height=>132,-background=>'dark slate gray',)->pack;
 $c->configure(-image=>'image');

 $label=$c1->Label(-anchor=>'n',-relief=>'sunken',-borderwidth=>2,-width=>29,-height=>1.5)->pack(-side=>'top');
 $doc=$c1->Button(-text=>'Show documentation',-width=>'27', -height=>'1')->pack(-side=>'top');
 $mainwin->bind($doc,"<ButtonPress-1>",sub{

# =comment
  my $doccode=
   '"'.
   'use Tk;'.
   '$docwin=MainWindow->new();'.
   '$docwin->configure(-title=>\'Documentation for '.$scriptHash->{$type}{$script}.'\');'.
   'my $scroll=$docwin->Scrolled(\'ROText\',-scrollbars=>\'e\',-wrap=>\'word\')->pack(-expand=>1,-fill=>\'both\');'.
   'if(-f \'./cow/MetaBrush/scripts/'."$type/$script".'.txt\'){'.
   ' $doctxt=q('.slurp("./cow/MetaBrush/scripts/$type/$script.txt").');'.
   '}else{'.
   ' $doctxt=\'No documentation\';'.
   '}'.
   '$scroll->insert(\'end\',$doctxt);'.
   'MainLoop;'.
   '"';

  #open FILE,'>tmp.pl';
  #print FILE "start perl -e $doccode";
  #close FILE;

  #system "start perl -e $doccode";
  system "start /m wperl -e $doccode";
# =cut

=comment
  $docwin->destroy if defined($docwin);
  $docwin=MainWindow->new();
  $docwin->configure(-title=>"Documentation for \'$scriptHash->{$type}{$script}\'");
  my $scroll=$docwin->Scrolled('ROText',-scrollbars=>'e',-wrap=>'word')->pack(-expand=>1,-fill=>'both');
  if(-f "./cow/MetaBrush/scripts/$type/$script.txt"){
   $doctxt=slurp("./cow/MetaBrush/scripts/$type/$script.txt");
  }else{
   $doctxt='No documentation';
  }
  $scroll->insert('end',$doctxt);
  undef($docwin->parent);
=cut

 });

 $mainwin->bind($mbtypes,"<ButtonPress-1>",sub{
  $script='';
  $photo->blank;
  $type=$mbtypes->get($mbtypes->curselection);
  $mbscripts->delete(0,$mbscripts->size);
  foreach $s (sort {uc($a) cmp uc($b);} keys %{$scriptHash->{$type}}){
   $mbscripts->insert('end',$s);
  }
 });

 $mainwin->bind($mbscripts,"<ButtonPress-1>",sub{
  $script=$mbscripts->get($mbscripts->curselection);
  $label->configure(-text=>$scriptHash->{$type}{$script});
  $photo->blank;
  $photo->configure(-file=>"./cow/MetaBrush/scripts/$type/$script.gif");
 });

 $c3=$mainwin->Frame()->pack(-side=>'top');

 $ok=$c3->Button(-text=>'OK',-width=>'10')->pack(-side=>'left');
 $mainwin->bind($ok,"<ButtonPress-1>",sub{
  $doit=1;
  #$docwin->destroy if defined($docwin);
  $mainwin->destroy;
 });

 $cancel=$c3->Button(-text=>'Cancel',-width=>'10')->pack();
 $mainwin->bind($cancel,"<ButtonPress-1>",sub{
  #$docwin->destroy if defined($docwin);
  $mainwin->destroy;
 });

 $doit=0;

 MainLoop();

 return if $doit==0;

 $mb_parms={};
 $mb_parms->{'scriptlet'}="$type/$script";
 Convert();

}

sub repeatLastMetaBrush {
 $showConfig = 0;
 $mb_parms=eval(slurp('mb_parms.txt'));
 Convert();
}

sub rotateTex {
 print "rotateTex $rx, $ry, $rz\n";
 my $bunch = shift;
 foreach $b ( @{$bunch->{blist}}) {
  for ($sideNum=0; $sideNum<$numFaces; $sideNum++) {
   my @vec = faceVector($sideNum);
   print Dumper(@vec);
   #print "$angle, $pitch\n";
  }
 }
}

sub translateTex {
 print "translateTex $x, $y, $z\n";
 my $bunch = shift;
 foreach $b ( @{$bunch->{blist}}) {
  for ($sideNum=0; $sideNum<$numFaces; $sideNum++) {
   #my ($angle, $pitch) = faceVector($sideNum);
   #print "$angle, $pitch\n";
  }
 }
}

sub faceVector {
 my $side = shift;
 my $brtype = $brush->{type} & 0xff;
 my $brkind = $brush->{kind} & 0xff;
 my @vec;
 if ($brkind==cube()) {
  if ($side==0) { # north
   if (($brtype==solid()) || ($brtype=air2solid()) || ($brtype=water2solid())) {
    @vec=(0,0,180);
   } else {
    @vec=(0,0,0);   
   }
  } elsif ($side==1) { # west
   if (($brtype==solid()) || ($brtype=air2solid()) || ($brtype=water2solid())) {
    @vec=(0,0,270);
   } else {
    @vec=(0,0,90);   
   }
  } elsif ($side==2) { # south
   if (($brtype==solid()) || ($brtype=air2solid()) || ($brtype=water2solid())) {
    @vec=(0,0,0);
   } else {
    @vec=(0,0,180);   
   }
  } elsif ($side==3) { # east
   if (($brtype==solid()) || ($brtype=air2solid()) || ($brtype=water2solid())) {
    @vec=(0,0,90);
   } else {
    @vec=(0,0,270);   
   }
  } elsif ($side==4) { # top
   if (($brtype==solid()) || ($brtype=air2solid()) || ($brtype=water2solid())) {
    @vec=(0,270,0);
   } else {
    @vec=(0,90,0);   
   }
  } elsif ($side==5) { # bottom
   if (($brtype==solid()) || ($brtype=air2solid()) || ($brtype=water2solid())) {
    @vec=(0,90,0);
   } else {
    @vec=(0,270,0);   
   }
  }
 } else {
  print "Unsupported brush type for faceIsPointing\n";
  @vec=(0,0,0);   
 }
 $vec[0]+=$rx; if ($vec[0]>=360) { $vec[0]-=360 };
 $vec[1]+=$ry; if ($vec[1]>=360) { $vec[1]-=360 };
 $vec[2]+=$rz; if ($vec[2]>=360) { $vec[2]-=360 };

 @vec;
}

sub retex {
 my $texture = shift;
 if ($texture == deftex()) {
  return $texture;
 }
 if ($texture == jorge()) {
  return $texture;
 }
 if ($texture == sky()) {
  return $texture;
 }
 if (defined($mistextures->{$texture})) {
  my ($j1,$j2,$j3,$j4,$j5,$tmp) = split ';', $mistextures->{$texture};
  return $tl->texture($tmp);
 }
}

sub retex2 {
 local $texture = shift;
 local $mistextures=shift;
 if ($texture == deftex()) {
  return $texture;
 }
 if ($texture == jorge()) {
  return $texture;
 }
 if ($texture == sky()) {
  return $texture;
 }
 if (defined($mistextures->{$texture})) {
  local ($j1,$j2,$j3,$j4,$j5,$tmp) = split ';', $mistextures->{$texture};
  return $tl->texture($tmp);
 }
}

sub trim {
 local $tmp=shift;
 $tmp=~s/^\s+//;
 $tmp=~s/\s+$//;
 $tmp;
}

sub preprocess {
 local $file=shift;
 if($file=~/^'.+'$/){
  $file=~s/^'//; 
  $file=~s/'$//;
 }elsif($file=~/^\".+\"$/){
  $file=~s/^\"//; 
  $file=~s/\"$//;
 } 
 return unless -f $file;
 local $str='';
 local *FILE;
 open(FILE,$file) or return;
 while(<FILE>){
  local $tmp=trim($_);chomp($tmp);
  if($tmp=~/#include/){
   (local $a,$b)=split(' ',$tmp);
   chomp($b);
   if($b=~/^'.+'$/){
    $b=~s/^'//; 
    $b=~s/'$//;
   }elsif($b=~/^\".+\"$/){
    $b=~s/^\"//; 
    $b=~s/\"$//;
   } 
   local $fileDir=getDir($file);
   $str.=preprocess($fileDir.$b);
  }else{
   $str.=$_;
  }
 }
 $str;
}

sub getDir {
 local $file=shift;
 $retVal='';
 for(local $i=length($file)-1; $i>=0; $i--){
  $tmp=substr($file,$i,1);
  if($tmp eq '/' or $tmp eq "\\"){
   $retVal=substr($file,0,$i+1);
   last;
  }
 }
 $retVal;
}

sub splitTex {
 local $tex=shift;
 local @retVal;
 for(local $i=length($tex)-1; $i>=0; $i--){
  $tmp=substr($tex,$i,1);
  if($tmp eq '/'){
   $retVal[0]=substr($tex,0,$i);
   $retVal[1]=substr($tex,$i+1);
   last;
  }
 }
 @retVal;
}

sub by_num { $a <=> $b; }

sub configure {

 return if $showConfig==0;

 my $tmpParms=shift;
 my $defTx=shift;

 foreach my $k (keys %$tmpParms){
  $mb_parms->{$k}=$tmpParms->{$k};
 }

 my $lablw=1;
 my $dataw=24;
 my $w;
 my $mywidgets;
 my $val;
 my $doit;
 foreach my $k (sort {uc($a) cmp uc($b);} keys %$mb_parms){
  $w=length($k);
  $lablw=$w if $w>$lablw;
  if(ref($mb_parms->{$k}) eq 'ARRAY'){
   foreach my $s (@{$mb_parms->{$k}}){
    $w=length($s);
    $dataw=$w if $w>$dataw;
   }
  }else{
   $w=length($mb_parms->{$k});
   $dataw=$w if $w>$dataw;
  }
 }

 my $mainwin=MainWindow->new();
 $mainwin->configure(
  -title=>'MetaBrush Options'
 );

 my $frame=$mainwin->Frame(-relief=>'groove',-borderwidth=>'2')->pack();
 my $scroll=$frame->Scrolled('Pane',-scrollbars=>'e')->pack(-side=>'top',-fill=>'both');
 $scroll->configure(-width=>0,-height=>0);
 $mb_parms->{'Texture Scheme'}='default' if !defined($mb_parms->{'Texture Scheme'});

 foreach my $k (sort {uc($a) cmp uc($b);} keys %$mb_parms){
  next if $k eq 'scriptlet';
  $frame=$scroll->Frame()->pack();
  $frame->Label(-text=>$k,-width=>$lablw,-anchor=>'ne')->pack(-side=>'left',-anchor=>'ne');
  if($k eq 'Texture Scheme'){
   $w=$frame->Button(-width=>$dataw-2,-height=>1,-text=>$mb_parms->{$k})->pack(-side=>'right');
   $mainwin->bind($w,"<ButtonPress-1>",sub{
    my $txs = $mainwin->getOpenFile(
     -title            => 'Select texture scheme',
     -filetypes        => [['Texture scheme Files', '*.txs']],
     -initialfile      => '*.txs',
     -defaultextension => 'txs',
     -initialdir       => '.\cow\MetaBrush\txscheme',
    );
    my @tmp=split(/\//,$txs);
    $txs=pop(@tmp);
    @tmp=split(/\./,$txs);
    $txs=$tmp[0];
    $mywidgets->{'Texture Scheme'}->configure(-text=>$txs) if (defined($txs) && $txs ne '');
   });
  }elsif(ref($mb_parms->{$k}) eq 'ARRAY'){
   $w=$frame->Listbox(-selectmode=>'single',-background=>'white',-width=>$dataw)->pack(-side=>'right');
   foreach my $s (@{$mb_parms->{$k}}){
    $w->insert('end',$s);
   }
   $w->activate(0); # why doesn't this work?
   $w->configure(-height=>$w->size);
  }else{
   $w=$frame->Entry(-width=>$dataw)->pack(-side=>'right');
   $w->insert(0,$mb_parms->{$k});
  }
  $mywidgets->{$k}=$w;
 }

 $frame=$mainwin->Frame()->pack();
 $w=$frame->Button(-text=>'OK',-width=>'10')->pack(-side=>'left');
 $mainwin->bind($w,"<ButtonPress-1>",sub{
  foreach $k (keys %$mywidgets){
   $w=$mywidgets->{$k};
   if($k eq 'Texture Scheme'){
    #$val='blah';
    $val=$w->cget(-text);
   } elsif($w->class eq 'Entry'){
    $val=$w->get;
   } elsif($w->class eq 'Listbox'){
    $cur=$w->curselection;
    if(defined($cur)){
     $val=$w->get($cur);
    }else{
     $val=$mb_parms->{$k}[0];
    }
   }
   if(defined($val) && $val ne ''){
    $mb_parms->{$k}=$val;
   }
  }
  $doit=1;
  $mainwin->destroy;
 });

 $w=$frame->Button(-text=>'Cancel',-width=>'10')->pack(-side=>'top');
 $mainwin->bind($w,"<ButtonPress-1>",sub{
  $mainwin->destroy;
 });

#=comment
   $mainwin->bind($txbtn,"<ButtonPress-1>",sub{
    my $txs = $mw->getOpenFile(
     -title            => 'Select texture scheme',
     -filetypes        => [['Texture scheme Files', '*.txs']],
     -initialfile      => '*.txs',
     -defaultextension => 'txs',
     -initialdir       => './cow/MetaBrush/txscheme/',
    );
    $mywidgets->{'Texture Scheme'}->configure(-text=>$txs);
    Win32::MsgBox('Hey!');
   });
#=cut

 MainLoop();

 exit(0) if $doit==0;

 loadTexScheme($defTx);

}

sub importMis {
 $showConfig=0;
 $mb_parms={};
 $mb_parms->{'scriptlet'}='mis2vbr';
 Convert();
}

sub loadTexScheme {
 my $defTx=shift;
 my $txscheme=$mb_parms->{'Texture Scheme'};
 $tx={};
 my $path='./cow/MetaBrush/txscheme';
 eval(slurp("$path/default.txs"));
 if(defined($txscheme) && $txscheme ne '' && $txscheme ne 'default'){
  eval(preprocess("$path/$txscheme.txs"));
 }
 foreach my $k (keys %$defTx){
  $tx->{$k}=$defTx->{$k} if (defined($defTx->{$k}) && $defTx->{$k} ne '');
 }
}

# This is only here because it's not exported from Bunch.pm
sub derot {
  return ($_[0]*45)/8192;
}

1;
