use File::Copy;
use PPM;

# Install Tk if necessary

print "Checking for Tk...\n";
$TkInstalled=PPM::VerifyPackage(package=>'Tk');
if(defined($TkInstalled) && $TkInstalled==0){
 print "Tk found.\n\n";
}else{
 print "Tk not found, installing...\n";
 print "If you are not currently connected to the internet, please connect now.\n";
 print "Press Enter when you are connected to the internet.\n";
 <STDIN>;
 $x=PPM::InstallPackage(package=>'Tk');
 if($x==0){
  print "Could not install Tk!\n";
  exit(1);
 }else{
  print "Tk successfully installed\n\n";
 }
}

# Check a few files and directories

print "Checking for a few files...\n";
checkFile('./utils.osm');
checkFile('./cow/Cowgen/Bunch.pm');
checkDir('./cow/data');
checkDir('./cow/MetaBrush/scripts');
checkDir('./cow/MetaBrush/txscheme');
print "Files look OK.\n\n";

# Edit menus.cfg

print "Editing menus.cfg...\n";
print "Press \"Y\" and Enter to edit menus.cfg, or just Enter to abort.\n";
$answer=uc(<STDIN>);
chomp($answer);
if($answer ne 'Y'){
 exit(0);
}

$mainmenu=<<ENDDOC;
menu_metabr Create MetaBrush:script_test CreateMetaBrush
menu_metabr_1 Repeat Last MetaBrush:script_test RepeatLastMetaBrush
menu_metabr_2 Import mis file:script_test ImportMis
menu_metabr_3 Undo (reload .mis):load_file mb_template.mis
ENDDOC

open(OLDMNU,"<menus.cfg") or die "Can't open menus.cfg\n";

@newmenu;
$foundit=0;
$lastedit=0;
$lasteditidx=0;
$i=-1;
$lastblank=0;
while(<OLDMNU>){
 next if(/^menu_metabr/);
 chomp();
 $_=~s/\s+$//;
 if($_ eq ''){
  if($lastblank==0){
   $lastblank=1;
  }else{
   next;
  }
 }else{
  $lastblank=0;
 }
 $i++;
 if($foundit==0){
  if(/^menu_edit/){
   if(/MetaBrush:menu_metabr/){
    $foundit=1;
   }else{
    if(/^menu_edit /){
     $lasteditidx=$i if($i==0);
    }elsif(/^menu_edit_/){
     my $tmp=substr($_,10,1)+0;
     if($tmp>$lastedit){
      $lastedit=$tmp;
      $lasteditidx=$i;
     }
    }
   }
  }
 }
 s/:\s*new_world\s*/:run new_world/;
 s/:\s*load_file\s*/:run load_file/;
 $newmenu[scalar(@newmenu)]=$_;
}
close OLDMNU;

$mb='MetaBrush:menu_metabr';
if($foundit==0){
 my $tmp;
 if($lastedit==0){
  $tmp=trim(substr(@newmenu[$lasteditidx],9));
 }else{
  $tmp=trim(substr(@newmenu[$lasteditidx],11));
 }
 my $tmp="$tmp|$mb";
 if(length($tmp)>78){
  $lastedit++;
  for($i=scalar(@newmenu); $i>$lasteditidx; $i--){
   $newmenu[$i]=$newmenu[$i-1];
  }
  $newmenu[$lasteditidx]="menu_edit_$lastedit $mb";
 }else{
  $tmp=@newmenu[$lasteditidx];
  $tmp=~s/\s+$//;
  @newmenu[$lasteditidx]="$tmp|$mb";
 }
}

open(NEWMNU,">newmenus.cfg") or die "Can't open newmenus.cfg\n";
foreach(@newmenu){
 print NEWMNU "$_\n";
}
print NEWMNU "\n";
print NEWMNU $mainmenu;
print NEWMNU $mbmenudata;
print NEWMNU $menudata;
close NEWMNU;

copy('menus.cfg','menus.cfg.metabrush_backup');
copy('newmenus.cfg','menus.cfg');
unlink('newmenus.cfg');

print "menus.cfg successfully edited.\n\n";

# Edit dromed.cfg

print "Editing dromed.cfg...\n";
print "Press \"Y\" and Enter to edit dromed.cfg, or just Enter to abort.\n";
$answer=uc(<STDIN>);
chomp($answer);
if($answer ne 'Y'){
 exit(0);
}

$loadutils="script_load utils";

open(OLDDRM,"<dromed.cfg") or die "Can't open dromed.cfg\n";
open(NEWDRM,">newdromed.cfg") or die "Can't open newdromed.cfg\n";

while(<OLDDRM>){
 chomp();
 next if(/^$loadutils$/);
 print NEWDRM "$_\n";
}
print NEWDRM "$loadutils\n";
close OLDDRM;
close NEWDRM;

#copy('dromed.cfg','dromed.cfg.metabrush_backup');
#copy('newdromed.cfg','dromed.cfg');
#unlink('newdromed.cfg');

print "dromed.cfg successfully edited.\n\n";

# Update scriptlets

print "Updating list of scriptlets...\n";
system 'perl update_scripts.pl';
print "Done\n";

sub trim {
 {
  my $tmp=shift;
  $tmp=~s/^\s+//;
  $tmp=~s/\s+$//;
  $tmp;
 }
}

sub checkFile {
 $file=shift;
 return if -f $file;
 print "Error! File \"$file\" not found!\n";
 exit(1);
}

sub checkDir {
 $dir=shift;
 return if -d $dir;
 print "Error! Directory \"$dir\" not found!\n";
 exit(1);
}
